#include <iostream>
#include "point.hpp"
#include <boost/mpi.hpp>

const int MASTER=0; 

namespace mpi = boost::mpi;
int main (int argc, char *argv[])
{

	int npoints;
	mpi::environment env(argc, argv);
  	mpi::communicator world;
	if (world.rank() == MASTER)
	{
		std::cout << "inserire N: ";
		std::cin >> npoints;
		for (int i=1; i< world.size(); i++)
			world.send(i,0,npoints);
	}
	else
		world.recv(MASTER,mpi::any_tag,npoints);
	
	int N = npoints/world.size(); 
	int count=0;	
	for(int j=1; j<N; j++) 
	{
		point p;
		if (p.dist2()<1)
			count++;
	}
	double myPI = 4.0*count/N;
	if (world.rank() != MASTER) 
		world.send(MASTER,0,myPI);
	else 
	{
		double PI=myPI;
		for (int i = 1; i < world.size(); i++) 
		{
			double pirecv;
			world.recv(i,mpi::any_tag,pirecv);
			PI = PI + pirecv;
		}
		PI = PI/world.size();
		std::cout << "PI=" << PI << std::endl;
	}
		
	return 0;
}
