#include <iostream>
#include "point.hpp"
#include <boost/mpi.hpp>

const int MASTER=0; 

namespace mpi = boost::mpi;
int main (int argc, char *argv[])
{

	int npoints;
	mpi::environment env(argc, argv);
  	mpi::communicator world;
	if (world.rank() == MASTER)
	{
		std::cout << "inserire N: ";
		std::cin >> npoints;
	}
	broadcast(world,npoints,MASTER);
	int N = npoints/world.size(); 
	int count=0;	
	for(int j=1; j<N; j++) 
	{
		point p;
		if (p.dist2()<1)
			count++;
	}
	double myPI = 4.0*count/N;
	double PI;
	reduce(world, myPI, PI, std::plus<double>(),MASTER);
	if (world.rank() == MASTER) 
		std::cout << "PI=" << PI/world.size() << std::endl;
		
	return 0;
}
