#include <iostream>
#include <boost/mpi.hpp>

const int MASTER=0;

using namespace std;
namespace mpi = boost::mpi;

bool isprime(int n);

int main (int argc, char *argv[])
{

	mpi::environment env(argc, argv);
  	mpi::communicator world;
  	int rank = world.rank();
  	int numtasks = world.size();
  	int LIMIT;
  	if (rank == MASTER)
	{
		cout << "inserire LIMIT: ";
		cin >> LIMIT;
	}
	
	broadcast(world,LIMIT,MASTER);

	int mystart = (rank*2)+11;
	int stride   = numtasks*2; 
	int pc=0; 
	int foundone = 0;
	
	for (int n=mystart; n<=LIMIT; n=n+stride) 
	{
		if (isprime(n)) 
		{
			pc++;
			foundone = n;
		}
	}
	
	if (rank==MASTER)
	{
		int maxprime, pcsum;
		reduce(world, pc, pcsum, std::plus<int>(), MASTER);
		reduce(world, foundone, maxprime, mpi::maximum<int>(), MASTER);
		pcsum = pcsum + 4;  // conta i primi 4 (2,3,5,7)      
		cout << "found= " << pcsum << " largest= " << maxprime << endl;
	}
	else
	{
		reduce(world, pc, std::plus<int>(), MASTER);
		reduce(world, foundone, mpi::maximum<int>(), MASTER);
	}
	
	return 0;
}

bool isprime(int n)
{
	for (int i=2; i<n; i++)
		if (n%i==0)
			return false;
	return true;
}
	
